// Script for controlling slaves with subcontrol
setInfos(6, "subcontrol v2", "Script for controlling slaves using subcontrol script, NOT for subs",
		"Liz", "v2", 0x222222, "en", ["maledom","femaledom","internet"]);

// See main file for comments
javax.net.ssl.HttpsURLConnection.setDefaultHostnameVerifier(new javax.net.ssl.HostnameVerifier() {
      public boolean verify(String hostname,
            javax.net.ssl.SSLSession sslSession) {
         return hostname.equals(sslSession.getPeerHost());
   }
});
// ******************** Key Functions ************************************
// SendPLImage
//SendPLImage("111X111","Profile","test.img");
def SendPLImage = { pid, itype, filename ->
	def url = new java.net.URL('https://play-link.com/subcontrol/sendimage.php')

	def conn = url.openConnection();
	conn.setDoInput(true);
	conn.setDoOutput(true);
	conn.setRequestMethod("POST");
	conn.setReadTimeout(120 * 1000);
	conn.setRequestProperty("Accept",
		"text/html,application/xhtml+xml,"
			+ "application/xml;q=0.9,*/*;q=0.8");
	conn.setRequestProperty("Content-Type",
		"multipart/form-data; boundary=BoBoBoBa");
	conn.setRequestProperty("Accept-Encoding", "deflate");
	def os = conn.getOutputStream();
	def pw = new java.io.PrintWriter(os, true);

	pw.write("\n--BoBoBoBa\n")
	pw.write("Content-Disposition: form-data; name=\"id\"\n")
	pw.write("Content-Type: text/plain; charset=UTF-8\n\n")
	pw.write(pid)
	pw.write("\n--BoBoBoBa\n")
	pw.write("Content-Disposition: form-data; name=\"itype\"\n")
	pw.write("Content-Type: text/plain; charset=UTF-8\n\n")
	pw.write(itype)
	pw.flush();
	
	pw.write("\n--BoBoBoBa\n" +
			"Content-Disposition: form-data; name=\"fileToUpload\"; filename=\"image.jpg\"\n" +
			"Content-Transfert-encoding: binary\n" +
			"Content-Type: image/jpeg\n\n");
	pw.flush();
	def file = new File(filename)
	os.write(file.getBytes(), 0, file.getBytes().size());
	os.flush();
	pw.write("\n--BoBoBoBa--\n");
	pw.flush();
	
	def buffer = new byte[1024];
	def is = conn.getInputStream();
	is.read(buffer, 0, 1024);
	def allResponse = new String(buffer);
	is.close();
	return allResponse
}

// DownloadFile function to keep local version of tasks up-to-date so not needing to
// keep checking with server.. May also use for auto script update?
def downloadFile = { dlink,dfile ->
  int len1 = 0;
  InputStream is=null;
  OutputStream os=null;
  try {
    URL url=new URL(dlink);
    is=url.openStream();
    os=new FileOutputStream(new File("scripts/"+dfile));
    byte[] buff=new byte[4096];
    while (-1 != (len1=is.read(buff))) {
      os.write(buff,0,len1);
    }
    os.flush();
  }
  catch (  Exception ex) {
    return false;
  }
  finally {
    if (os != null) try {
      os.close();
    }
    catch (IOException ex) {
    }
    if (is != null) try {
      is.close();
    }
    catch (IOException ex) { }
  }
  return true;
}
// ******************** End of Key Functions ******************************

//Splash and version check - keep version numbers same for control and sub scripts so in sync?		
show(null)
setImage("subcontrol/splashv2.png")

// Should do version check...

show("Loading...");

//check sex - Master or Mistress?
def mpic = null
def spic = null
def Msex = (!(!loadBoolean("intro.female")))
def MText = "Mistress"
if(!Msex)
  MText = "Master"
  
def timenow = getTime();
def mcode = loadString("subcontrol_control.mistress_code")
if (mcode != null)
  mcode = mcode.toUpperCase().replaceAll("[^0-9X]", "")
  
def scode = ""
def slist = loadString("subcontrol_control.subs") // store more than one sub in a list? - not on server!
if (slist == null)
  slist = ""
else
  slist = slist.toUpperCase().replaceAll("[^0-9Z,]", "")
  
def List<String> Subs = slist.split(',')
def List<String> SubsN = []
def s_count = 0;
if (slist != "")
  s_count = Subs.size();
  
//Sub Vars
def sname
def s_times
def s_picchance
def s_watersports
def s_public
def s_reviewwebcam = false
def s_warnwebcam = false
def mpassword = loadString("subcontrol.control.password")
  
//Create new mistress/master id if not found
if (mcode == null) {
  show("This script is for Masters and Mistresses only - Are you sure you should be here? If not exit now!")
  showButton("Ok")

  //have option to enter it! If being a Mistress on more than once device
  show("Welcome.\nWe do not have a record of you using this script before, generating a new ID");
  def tcode = getTime()-1426441764;
  mcode = getRandom(100000)+"X"+tcode;   // New code based on time to keep a match from happening
//	def i = getInteger("?",0);
  save("subcontrol_control.mistress_code", mcode)
  wait(4)
  show("Your "+MText+" ID is: "+mcode+"\n\nYour subs will need to enter it when they run their script for the first time. You will be able to see it at any time you run this script")
  showButton("Ok");
  
  // Gen online profile - Will have way to change it later
  show("We need to setup a profile that your subs will see ("+mcode+")...");
  wait(4)
  def mname = getString("What name would you like your subs to use?",loadString("intro.name"));
  show("Now we need a profile pic");
  def myfilename = getFile("Please choose your picture")  
  setImage(myfilename)
  mpic = myfilename
  // Upload Profile Image
  if (myfilename != "null") {
    SendPLImage(scode,"Profile",myfilename)
  }
  
  if (mpassword == null) { 
    mpassword = getString("You are now required to secure your account with a password:","password");
  }
  def v2profile = "https://play-link.com/subcontrol/save.php?id="+mcode+"&name="+URLEncoder.encode(mname,"UTF-8")+"&password="+URLEncoder.encode(mpassword,"UTF-8")+"&subs="+slist+"&sex="+Msex+"&"
	
  save("subcontrol.control.v2profile",v2profile)
  v2profile = v2profile.toURL().text
  show(v2profile) // Show if problem
  if (v2profile.contains("Error")) {
    showButton("Ok")
  }
  save("subcontrol.control.password",mpassword)
}
// Reset MText
if (Msex) {
  MText = "Mistress"
} else {
  MText = "Master"
}

// *********************** Version 2 control will be online *************************
// Will allow basic status checks etc in here later whenhave time to write ;-)

if (mpassword == null) { 
  mpassword = getString("You are now required to secure your account with a password:","password");
}
show("Goto website to control subs")
def url = "https://play-link.com/subcontrol/control.php?id="+mcode+"&password="+URLEncoder.encode(mpassword,"UTF-8")+"&"
useUrl(url)

wait(1)
//exit()

// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/

/*
 * Resources
 */
